/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef BINDAUDIO_H
#define BINDAUDIO_H

#include "squirrel.h"

namespace bipscript {

namespace binding
{
    // object references to types in this package
    extern HSQOBJECT AudioBeatTrackerObject;
    extern HSQOBJECT AudioBufferObject;
    extern HSQOBJECT AudioBufferEventObject;
    extern HSQOBJECT AudioClipObject;
    extern HSQOBJECT AudioConnectionObject;
    extern HSQOBJECT AudioConnectorObject;
    extern HSQOBJECT AudioMixerObject;
    extern HSQOBJECT AudioMixerGainObject;
    extern HSQOBJECT AudioMultiInputObject;
    extern HSQOBJECT AudioMultiOutputObject;
    extern HSQOBJECT AudioOnsetDetectorObject;
    extern HSQOBJECT AudioOutputObject;
    extern HSQOBJECT AudioInputObject;
    extern HSQOBJECT AudioStereoInputObject;
    extern HSQOBJECT AudioStereoOutputObject;
    // method to bind this package
    void bindAudio(HSQUIRRELVM vm);
}}

#endif // BINDAUDIO_H
