/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef BINDMIDI_H
#define BINDMIDI_H

#include "squirrel.h"

namespace bipscript {

namespace binding
{
    // object references to types in this package
    extern HSQOBJECT MidiAbcObject;
    extern HSQOBJECT MidiBeatTrackerObject;
    extern HSQOBJECT MidiClockGeneratorObject;
    extern HSQOBJECT MidiConnectionObject;
    extern HSQOBJECT MidiConnectorObject;
    extern HSQOBJECT MidiCopyrightObject;
    extern HSQOBJECT MidiCuePointObject;
    extern HSQOBJECT MidiMessageEventObject;
    extern HSQOBJECT MidiFileObject;
    extern HSQOBJECT MidiInputObject;
    extern HSQOBJECT MidiInstrumentObject;
    extern HSQOBJECT MidiLyricObject;
    extern HSQOBJECT MidiMarkerObject;
    extern HSQOBJECT MidiNoteObject;
    extern HSQOBJECT MidiNoteEventObject;
    extern HSQOBJECT MidiNoteOnObject;
    extern HSQOBJECT MidiNoteOffObject;
    extern HSQOBJECT MidiKeySignatureObject;
    extern HSQOBJECT MidiControlObject;
    extern HSQOBJECT MidiMMLObject;
    extern HSQOBJECT MidiPatternObject;
    extern HSQOBJECT MidiSequenceObject;
    extern HSQOBJECT MidiTempoChangeObject;
    extern HSQOBJECT MidiTextObject;
    extern HSQOBJECT MidiTimeSignatureObject;
    extern HSQOBJECT MidiTrackNameObject;
    extern HSQOBJECT MidiOutputObject;
    extern HSQOBJECT MidiPitchBendObject;
    extern HSQOBJECT MidiProgramChangeObject;
    extern HSQOBJECT MidiTabObject;
    // method to bind this package
    void bindMidi(HSQUIRRELVM vm);
}}

#endif // BINDMIDI_H
