/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "bindnet.h"
#include "bindinterface.h"
#include "bindutil.h"

#include "net.h"
#include <stdexcept>
#include <cstring>

namespace bipscript {

using namespace net;

namespace binding {

// object references to types in this package


void bindNet(HSQUIRRELVM vm)
{
    BindUtil binding(vm);
    binding.startTable("Net", 3);

    // create enumeration
    sq_pushstring(vm, "Protocol", -1);
    sq_newtable(vm);
    sq_pushstring(vm, "UDP", -1);
    sq_pushinteger(vm, net::UDP);
    sq_newslot(vm, -3, true);
    sq_pushstring(vm, "TCP", -1);
    sq_pushinteger(vm, net::TCP);
    sq_newslot(vm, -3, true);
    sq_newslot(vm, -3, true);
    binding.endTable(); // end package table
}
}}
